clc
clear all

% optimization options
% min_totCost_0: option for base case simulation of the FED system where historical data of the generating units are used and the external connection is kept as a slack (for balancing)
% min_totCost:  weighting factor for total cost to use in the minimization function - it is alpha in equation (1) of the article- weighting factor for cost
% min_totPE:    weighting factor for NRE to use in the minimization function
% min_totCO2:   weighting factor for CO2 emissions to use in the minimization function - it is beta value in the equation (1) of the article 


% Initial run
opt_RunGAMSModel=1;
opt_marg_factors=1;
synth_baseline=0;
IPCC_factors=1; %Change to the new factors for CO2 and PE
for IPCC_factors=[1]

% weighting factor for emissions (min_totCO2 OR beta) is changed from 0 to 1 while keeping min_totCost equal to 1
for i=1:13   
%copyfile('result_temp_bkup.xlsx', 'result_temp.xlsx')
    disp(['Case no ' num2str(i)])

    if i==1
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0;
    end
    if i==2
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.000001;
    end  
    if i==3
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.000005;
    end
    if i==4
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.00001;
    end
    if i==5
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.00005;
    end
    
    if i==6
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.0001;
    end
    if i==7
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.0005;
    end
    if i==8
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.001;
    end

    if i==9
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.005;
    end
    if i==10
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.01;
    end
    if i==11
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.05;
    end
    if i==12
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.1;
    end
    if i==13
        min_totCost_0=0;
        min_totCost=1;
        min_totPE=0;
        min_totCO2=0.95;
    end 
    
    
    
% Run FED model
[to_excel_el, to_excel_heat, to_excel_cool, to_excel_co2, Results]=FED_MAT_MAIN(opt_RunGAMSModel, opt_marg_factors, min_totCost_0, min_totCost, min_totPE, min_totCO2, synth_baseline);


% Save result files
result_path = ([cd '\results\' date '\']);
mkdir (result_path);
filename=[result_path 'Results_BAU=' num2str(min_totCost_0) '_MTC=' num2str(min_totCost) '_MCO2=' num2str(min_totCO2) '_MPE=' num2str(min_totPE) '_IPCC=' num2str(IPCC_factors) '_time=' num2str(length(Results)) 'h'];
save(filename,'Results')
filenamexls=[filename '.xlsx'];
copyfile('result_temp.xlsx', filenamexls)

end
end